Status: In Progress

Priority: Normal

Assignee:

Category: QGIS Server

Affected QGIS version:3.0.3 Regression?: No
Operating System: Windows Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 26930
Description

I'm having problems getting a WFS request using a filter with two conditions (BBOX + PropertylsEqual) to work with QGIS Server. My
goal is to get all features within a certain area that have an attribute with a certain value. Sounds simple enough.

http://localhost:8081/cgi-bin/gis.server?service=WFS&#38;request=GetFeature&#38;version=1.1.0&#38;map=C:\0SGeo4W\var\qqgis\gi
\overview.qgs&#38;srsname=EPSG:3857&#38;typename=projects&#38;outputformat=geojson&#38;filter=&amp;lt;Filter&amp;gt;&amp;lt;

And

;And

xmins="http://www.opengis.net/ogc"><Or><PropertylsEqual To><PropertyName>id</PropertyName><Literal>8</Literal></PropertylsEqu
alTo><PropertylsEqualTo><PropertyName>id</PropertyName><Literal>9</Literal></PropertylsEqualTo></Or><BBOX><PropertyName
>geometry</PropertyName><Envelope xmIns="http://www.opengis.net/gml"
srsName="EPSG:3857"><lowerCorner>1501468.311742801 6893026.717014579</lowerCorner><upperCorner>1505075.184015008
6896901.1188857835</upperCorner></Envelope></BBOX></And></Filter>

QGIS Server always returns an empty feature set on the combined request. Running separate requests with only a single filter condition
however returns the correct results. I'm unsure as to whether my filter syntax is somehow wrong or QGIS Server doesn't support logical
operators at all. Any help or fix would be appreciated!

>geome

History

#1 - 2018-06-05 06:59 PM - René-Luc RelLuc

A PR has been merged in 3.2 and probably fixed it.
https://github.com/qgis/QGIS/pull/7007

Can you test it ?

#2 - 2018-06-06 11:32 AM - Arnaud Morvan

Pull Request 7007 fix SRS issue only for the case BBOX is direct child of an And, itself direct child of the Filter Element, which may be a common case in a
GetFeature request.

#3 - 2018-06-08 11:53 AM - Andreas Steffens

Yes ... i can confirm that 7007 fixes the issue under the condition mentioned by Arnaud.

#4 - 2018-06-14 02:41 PM - Alessandro Pasotti
- Status changed from Open to In Progress
http://localhost:8081/cgi-bin/gis.server?service=WFS&#38;request=GetFeature&#38;version=1.1.0&#38;map=C:\OSGeo4W\var\qgis\gis\overview.qgs&#38;srsname=EPSG:3857&#38;typename=projects&#38;outputformat=geojson&#38;filter=&amp;lt;Filter&amp;gt;&amp;lt;And
http://localhost:8081/cgi-bin/gis.server?service=WFS&#38;request=GetFeature&#38;version=1.1.0&#38;map=C:\OSGeo4W\var\qgis\gis\overview.qgs&#38;srsname=EPSG:3857&#38;typename=projects&#38;outputformat=geojson&#38;filter=&amp;lt;Filter&amp;gt;&amp;lt;And
http://localhost:8081/cgi-bin/gis.server?service=WFS&#38;request=GetFeature&#38;version=1.1.0&#38;map=C:\OSGeo4W\var\qgis\gis\overview.qgs&#38;srsname=EPSG:3857&#38;typename=projects&#38;outputformat=geojson&#38;filter=&amp;lt;Filter&amp;gt;&amp;lt;And
https://github.com/qgis/QGIS/pull/7007

Is this now fixed in master?
